Bug 18483 - Customised help: Enhance staff client with news based, easily editable help system
Summary: Customised help: Enhance staff client with news based, easily editable help s...
Status: Signed Off
Alias: None
Product: Koha
Classification: Unclassified
Component: Staff Client (show other bugs)
Version: master
Hardware: All All
: P5 - low enhancement (vote)
Assignee: Marc Véron
QA Contact: Testopia
URL:
Whiteboard:
Keywords:
Depends on: 13835 18472
Blocks: 18515 18516
  Show dependency treegraph
 
Reported: 2017-04-22 22:20 UTC by Marc Véron
Modified: 2017-08-04 09:27 UTC (History)
1 user (show)

See Also:
Change sponsored?: ---
Patch complexity: Medium patch
Bot Control: ---
When did the bot last check this:
Who signed the patch off:
Text to go in the release notes:


Attachments
Bug 18483 - Customised help: Enhance staff client with news based, easily editable help system (11.62 KB, patch)
2017-04-22 22:27 UTC, Marc Véron
Details | Diff | Splinter Review
Bug 18483 - Customised help: Enhance staff client with news based, easily editable help system (11.62 KB, patch)
2017-04-23 07:39 UTC, Marc Véron
Details | Diff | Splinter Review
Bug 18483 - Customised help: Enhance staff client with news based, easily editable help system (15.42 KB, patch)
2017-04-23 22:12 UTC, Marc Véron
Details | Diff | Splinter Review
Bug 18483 - Customised help: Enhance staff client with news based, easily editable help system (20.67 KB, patch)
2017-04-24 23:17 UTC, Marc Véron
Details | Diff | Splinter Review
Bug 18483 - Customised help: Enhance staff client with news based, easily editable help system (21.63 KB, patch)
2017-04-26 08:17 UTC, Marc Véron
Details | Diff | Splinter Review
Bug 18483 - Customised help: Enhance staff client with news based, easily editable help system (22.94 KB, patch)
2017-04-26 12:15 UTC, Marc Véron
Details | Diff | Splinter Review
Bug 18483 - Customised help: Enhance staff client with news based, easily editable help system (27.85 KB, patch)
2017-04-27 21:08 UTC, Marc Véron
Details | Diff | Splinter Review
Bug 18483 - Customised help: Enhance staff client with news based, easily editable help system (29.91 KB, patch)
2017-04-28 09:45 UTC, Marc Véron
Details | Diff | Splinter Review
Bug 18483 - Customised help: Enhance staff client with news based, easily editable help system (29.72 KB, patch)
2017-04-28 22:11 UTC, Marc Véron
Details | Diff | Splinter Review
Bug 18483 - Customised help: Enhance staff client with news based, easily editable help system (29.70 KB, patch)
2017-04-29 10:14 UTC, Marc Véron
Details | Diff | Splinter Review
Bug 18483 - Customised help: Enhance staff client with news based, easily editable help system (32.31 KB, patch)
2017-04-29 14:33 UTC, Marc Véron
Details | Diff | Splinter Review
Bug 18483 - Customised help: Enhance staff client with news based, easily editable help system (35.84 KB, patch)
2017-04-30 17:18 UTC, Marc Véron
Details | Diff | Splinter Review
Bug 18483 - Customised help: Enhance staff client with news based, easily editable help system (38.22 KB, patch)
2017-04-30 19:53 UTC, Marc Véron
Details | Diff | Splinter Review
[SIGNED-OFF] Bug 18483 - Customised help: Enhance staff client with news based, easily editable help system (38.29 KB, patch)
2017-05-02 11:37 UTC, Josef Moravec
Details | Diff | Splinter Review

Note You need to log in before you can comment on or make changes to this bug.
Description Marc Véron 2017-04-22 22:20:26 UTC
Koha's staff client has a file based help system with an edit function for customising. However, the edited files have to be saved and restored with each release. Otherwise they are overwritten.

As an enhancement or alternative, the existing news system can be used to implement a complementing help system. Similar to the news, the text can be created for all branches or for individual branches. Help is context sensitive (based on the existing help system), and it can be created / edited directly from the help page (based on a user permission).

The display can be managed with a system preference (Bug 18472: Add system preference CustomOnlineHelpStaff to hide / select custom online help system).
Comment 1 Marc Véron 2017-04-22 22:27:42 UTC
Created attachment 62576 [details] [review]
Bug 18483 - Customised help: Enhance staff client with news based, easily editable help system

Koha's staff client has a file based help system with an edit function for customising.
However, the edited files have to be saved and restored with each release. Otherwise they
are overwritten.

As an enhancement or alternative, the existing news system can be used to implement a
complementing help system. Similar to the news, the text can be created for all branches
or for individual branches. Help is context sensitive (based on the existing help system),
 and it can be created / edited directly from the help page (based on a user permission).

The display can be managed with a system preference (Bug 18472: Add system preference
CustomOnlineHelpStaff to hide / select custom online help system).

This patch is a first draft. It is not yet ready for testing or sign-off.
Comment 2 Marc Véron 2017-04-23 07:39:51 UTC
Created attachment 62577 [details] [review]
Bug 18483 - Customised help: Enhance staff client with news based, easily editable help system

Koha's staff client has a file based help system with an edit function for customising.
However, the edited files have to be saved and restored with each release. Otherwise they
are overwritten.

As an enhancement or alternative, the existing news system can be used to implement a
complementing help system. Similar to the news, the text can be created for all branches
or for individual branches. Help is context sensitive (based on the existing help system),
 and it can be created / edited directly from the help page (based on a user permission).

The display can be managed with a system preference (Bug 18472: Add system preference
CustomOnlineHelpStaff to hide / select custom online help system).

This patch is a first draft. It is not yet ready for testing or sign-off.
Amended to resolve minor conflicts with Bug 18472
Comment 3 Marc Véron 2017-04-23 22:12:26 UTC
Created attachment 62579 [details] [review]
Bug 18483 - Customised help: Enhance staff client with news based, easily editable help system

Koha's staff client has a file based help system with an edit function for customising.
However, the edited files have to be saved and restored with each release. Otherwise they
are overwritten.

As an enhancement or alternative, the existing news system can be used to implement a
complementing help system. Similar to the news, the text can be created for all branches
or for individual branches. Help is context sensitive (based on the existing help system),
 and it can be created / edited directly from the help page (based on a user permission).

The display can be managed with a system preference (Bug 18472: Add system preference
CustomOnlineHelpStaff to hide / select custom online help system).

This patch is a first draft. It is not yet ready for testing or sign-off.
Amended to resolve minor conflicts with Bug 18472
Amended to expand sysprefs from Bug 18472
Comment 4 Marc Véron 2017-04-24 23:17:03 UTC
Created attachment 62648 [details] [review]
Bug 18483 - Customised help: Enhance staff client with news based, easily editable help system

Koha's staff client has a file based help system with an edit function for customising.
However, the edited files have to be saved and restored with each release. Otherwise they
are overwritten.

As an enhancement or alternative, the existing news system can be used to implement a
complementing help system. Similar to the news, the text can be created for all branches
or for individual branches. Help is context sensitive (based on the existing help system),
 and it can be created / edited directly from the help page (based on a user permission).

The display can be managed with a system preference (Bug 18472: Add system preference
CustomOnlineHelpStaff to hide / select custom online help system).

This patch is a first draft. It is not yet ready for testing or sign-off.
Amended to resolve minor conflicts with Bug 18472
Amended to expand sysprefs from Bug 18472
Amended to add permissions
Comment 5 Marc Véron 2017-04-26 08:17:41 UTC
Created attachment 62705 [details] [review]
Bug 18483 - Customised help: Enhance staff client with news based, easily editable help system

Koha's staff client has a file based help system with an edit function for customising.
However, the edited files have to be saved and restored with each release. Otherwise they
are overwritten.

As an enhancement or alternative, the existing news system can be used to implement a
complementing help system. Similar to the news, the text can be created for all branches
or for individual branches. Help is context sensitive (based on the existing help system),
 and it can be created / edited directly from the help page (based on a user permission).

The display can be managed with a system preference (Bug 18472: Add system preference
CustomOnlineHelpStaff to hide / select custom online help system).

This patch is a first draft. It is not yet ready for testing or sign-off.
Amended to resolve minor conflicts with Bug 18472
Amended to expand sysprefs from Bug 18472
Amended to add permissions
Amended for visibility of edit buttons
Comment 6 Marc Véron 2017-04-26 12:15:10 UTC
Created attachment 62718 [details] [review]
Bug 18483 - Customised help: Enhance staff client with news based, easily editable help system

Koha's staff client has a file based help system with an edit function for customising.
However, the edited files have to be saved and restored with each release. Otherwise they
are overwritten.

As an enhancement or alternative, the existing news system can be used to implement a
complementing help system. Similar to the news, the text can be created for all branches
or for individual branches. Help is context sensitive (based on the existing help system),
 and it can be created / edited directly from the help page (based on a user permission).

The display can be managed with a system preference (Bug 18472: Add system preference
CustomOnlineHelpStaff to hide / select custom online help system).

This patch is a first draft. It is not yet ready for testing or sign-off.
Amended to resolve minor conflicts with Bug 18472
Amended to expand sysprefs from Bug 18472
Amended to add permissions
Amended for visibility of edit buttons
Amended for updatedb fixes
Comment 7 Marc Véron 2017-04-27 21:08:13 UTC
Created attachment 62804 [details] [review]
Bug 18483 - Customised help: Enhance staff client with news based, easily editable help system

Koha's staff client has a file based help system with an edit function for customising.
However, the edited files have to be saved and restored with each release. Otherwise they
are overwritten.

As an enhancement or alternative, the existing news system can be used to implement a
complementing help system. Similar to the news, the text can be created for all branches
or for individual branches. Help is context sensitive (based on the existing help system),
 and it can be created / edited directly from the help page (based on a user permission).

The display can be managed with a system preference (Bug 18472: Add system preference
CustomOnlineHelpStaff to hide / select custom online help system).

This patch is work in progress. It is not yet ready for testing or sign-off.
Amended to resolve minor conflicts with Bug 18472
Amended to expand sysprefs from Bug 18472
Amended to add permissions
Amended for visibility of edit buttons
Amended for updatedb fixes
Amended for managing permissions
Comment 8 Marc Véron 2017-04-28 09:45:39 UTC
Created attachment 62812 [details] [review]
Bug 18483 - Customised help: Enhance staff client with news based, easily editable help system

Koha's staff client has a file based help system with an edit function for customising.
However, the edited files have to be saved and restored with each release. Otherwise they
are overwritten.

As an enhancement or alternative, the existing news system can be used to implement a
complementing help system. Similar to the news, the text can be created for all branches
or for individual branches. Help is context sensitive (based on the existing help system),
 and it can be created / edited directly from the help page (based on a user permission).

The display can be managed with a system preference (Bug 18472: Add system preference
CustomOnlineHelpStaff to hide / select custom online help system).

This patch is work in progress. It is not yet ready for testing or sign-off.
Amended to resolve minor conflicts with Bug 18472
Amended to expand sysprefs from Bug 18472
Amended to add permissions
Amended for visibility of edit buttons
Amended for updatedb fixes
Amended for managing permissions
Amended to use news manging page as popup, needs Bug 13835 to test (not to apply)
Comment 9 Marc Véron 2017-04-28 22:11:08 UTC
Created attachment 62892 [details] [review]
Bug 18483 - Customised help: Enhance staff client with news based, easily editable help system

Koha's staff client has a file based help system with an edit function for customising.
However, the edited files have to be saved and restored with each release. Otherwise they
are overwritten.

As an enhancement or alternative, the existing news system can be used to implement a
complementing help system. Similar to the news, the text can be created for all branches
or for individual branches. Help is context sensitive (based on the existing help system),
 and it can be created / edited directly from the help page (based on a user permission).

The display can be managed with a system preference (Bug 18472: Add system preference
CustomOnlineHelpStaff to hide / select custom online help system).

This patch is work in progress. It is not yet ready for testing or sign-off.
Amended to resolve minor conflicts with Bug 18472
Amended to expand sysprefs from Bug 18472
Amended to add permissions
Amended for visibility of edit buttons
Amended for updatedb fixes
Amended for managing permissions
Amended to use news manging page as popup, needs Bug 13835 to test (not to apply)
Comment 10 M. Tompsett 2017-04-29 02:03:45 UTC
Comment on attachment 62892 [details] [review]
Bug 18483 - Customised help: Enhance staff client with news based, easily editable help system

Review of attachment 62892 [details] [review]:
-----------------------------------------------------------------

::: koha-tmpl/intranet-tmpl/prog/en/includes/header.inc
@@ +98,4 @@
>                      </li>
>                  </ul>
>              </li>
> +                [% IF Koha.Preference('HelpSystem').match('filebased|newsbased')  %]

Is there ever a method that won't require a Help link? This condition seems weird.

::: koha-tmpl/intranet-tmpl/prog/en/includes/help-bottom.inc
@@ +1,1 @@
> +[% USE Koha %]

I haven't checked, but does scoping require this?

::: koha-tmpl/intranet-tmpl/prog/en/includes/help-top.inc
@@ +5,2 @@
>  <link rel="stylesheet" type="text/css" href="[% interface %]/[% theme %]/css/help.css" />
> +[% USE Koha %]

Why a second time?
Comment 11 Marc Véron 2017-04-29 07:41:46 UTC
(In reply to M. Tompsett from comment #10)
> Comment on attachment 62892 [details] [review] [review]
> Bug 18483 - Customised help: Enhance staff client with news based, easily
> editable help system
> 
> Review of attachment 62892 [details] [review] [review]:
> -----------------------------------------------------------------

Thanks for testing and for your comments, I really appreciate!

Yes, there seems to be a scoping issue with [% USE Koha %] in includes. 

If the parent of an include has [% USE Koha %], it is visible for the include.
If the parent does not have [% USE Koha %], it is not visible for the include (even if a precedent sibling include has [% USE Koha %]).

I had a similar problem with Bug 18472 (see there comments #2 and #12).

BTW the patch is still work in progress. It is not yet ready for sign-off.
Comment 12 Marc Véron 2017-04-29 10:14:49 UTC
Created attachment 62898 [details] [review]
Bug 18483 - Customised help: Enhance staff client with news based, easily editable help system

Koha's staff client has a file based help system with an edit function for customising.
However, the edited files have to be saved and restored with each release. Otherwise they
are overwritten.

As an enhancement or alternative, the existing news system can be used to implement a
complementing help system. Similar to the news, the text can be created for all branches
or for individual branches. Help is context sensitive (based on the existing help system),
 and it can be created / edited directly from the help page (based on a user permission).

The display can be managed with a system preference (Bug 18472: Add system preference
CustomOnlineHelpStaff to hide / select custom online help system).

This patch is work in progress. It is not yet ready for testing or sign-off.
Amended to resolve minor conflicts with Bug 18472
Amended to expand sysprefs from Bug 18472
Amended to add permissions
Amended for visibility of edit buttons
Amended for updatedb fixes
Amended for managing permissions
Amended to use news manging page as popup, needs Bug 13835 to test (not to apply)
Amended to make it apply again on 18472

Still work in progress, not yet ready to test.
Comment 13 Marc Véron 2017-04-29 14:33:26 UTC
Created attachment 62899 [details] [review]
Bug 18483 - Customised help: Enhance staff client with news based, easily editable help system

Koha's staff client has a file based help system with an edit function for customising.
However, the edited files have to be saved and restored with each release. Otherwise they
are overwritten.

As an enhancement or alternative, the existing news system can be used to implement a
complementing help system. Similar to the news, the text can be created for all branches
or for individual branches. Help is context sensitive (based on the existing help system),
 and it can be created / edited directly from the help page (based on a user permission).

The display can be managed with a system preference (Bug 18472: Add system preference
CustomOnlineHelpStaff to hide / select custom online help system).

This patch is work in progress. It is not yet ready for testing or sign-off.
Amended to resolve minor conflicts with Bug 18472
Amended to expand sysprefs from Bug 18472
Amended to add permissions
Amended for visibility of edit buttons
Amended for updatedb fixes
Amended for managing permissions
Amended to use news managing page as popup, needs Bug 13835 to test (not to apply)
Amended to make it apply again on 18472
Amended for better cycle through popup

Still work in progress, not yet ready to test.
Comment 14 Marc Véron 2017-04-30 17:18:07 UTC
Created attachment 62900 [details] [review]
Bug 18483 - Customised help: Enhance staff client with news based, easily editable help system

Koha's staff client has a file based help system with an edit function for customising.
However, the edited files have to be saved and restored with each release. Otherwise they
are overwritten.

As an enhancement or alternative, the existing news system can be used to implement a
complementing help system. Similar to the news, the text can be created for all branches
or for individual branches. Help is context sensitive (based on the existing help system),
 and it can be created / edited directly from the help page (based on a user permission).

The display can be managed with a system preference (Bug 18472: Add system preference
CustomOnlineHelpStaff to hide / select custom online help system).

This patch is work in progress. It is not yet ready for testing or sign-off.
Amended to resolve minor conflicts with Bug 18472
Amended to expand sysprefs from Bug 18472
Amended to add permissions
Amended for visibility of edit buttons
Amended for updatedb fixes
Amended for managing permissions
Amended to use news managing page as popup, needs Bug 13835 to test (not to apply)
Amended to make it apply again on 18472
Amended for better cycle through popup
Amended for last steps before switching to NSO

Still work in progress, not yet ready to test.
Comment 15 Marc Véron 2017-04-30 19:53:14 UTC
Created attachment 62901 [details] [review]
Bug 18483 - Customised help: Enhance staff client with news based, easily editable help system

Koha's staff client has a file based help system with an edit function for
customising. However, the edited files have to be saved and restored with each
release. Otherwise they are overwritten.

As an enhancement or alternative, the existing news system is used to implement a
complementing help system. Similar to the news, the text can be created for all
branches or for individual branches. Help is context sensitive (based on the
existing help system), and it can be created / edited directly from the help page
(based on a user permission). Du to the need of this user permissen, a user
permission for editing news is implemented as well.

Display can be managed with a system preference (Bug 18472: Add system preference
to manage online help system). Preferences default to legacy (fiele based) help.

To test:
- Apply patch on top of Bug 18472, restart memcached and plack
- Update database (Alternative: fresh install)
- Log in as superlibrarian (later we test the permisisons)
- Verify that news behave as before
- Verify that legacy help works as before
- Locate system preferences 'EnableEditingFilebasedHelp' and 'Help system'
- For our tests, set 'EnableEditingFilebasedHelp' to 'No'
- In 'HelpSystem', uncheck 'File based'  (none selected)
- Refresh any page and verify that 'Help' Link in the main menu has vanished
- Check both 'File based' and 'News based'
- Verify that 'Help appears again in top menu
- Click 'Help' for any page, verify that, above the 'classic' filebased help, you
  see a title 'Help for (library name) and two buttons 'Add help for this page'
  and 'Add help for all pages'
- Close the help page
- Go back to system preferences, select 'News based' only for 'HelpSystem'
- Open Help again for any page
- Verify that the text from file based help no longer displays, you should have
  a title and buttons only at the moment.
- Click 'Add help for this page'. You are taken to the form you already know from
  editing 'News'
- Click 'Cancel'. You should be taken back to the help page as before
- Again click 'Add help for this page' and add an easyly identifiable title and
  some text, like you would do with news.
- Leave the new field 'Help key' unchanged.
- Submit. You should be taken back to the help you just created should appear
- Close help page and open it again to verify that the text persists (for this
  page)
- Go to an other page and verify that the help you added for the first page does
  not appear.
- Add a help entry using the button 'Add help for all pages'
- Go back to the first page you entered help for and verify, that it displays it's
  own help text and the text for all pages
- Edit one of the texts, verify that it saves correctly
- Add some more entries and verify that they appear as expected
- Go to More > Tools (in an other tab)
- Verify that the menu entry for News appears/disappears and changes text
  depending on the settings of system preference 'HelpSystem'
- Open 'News' rsp. 'Help', verify that entries appear depending on the settings
  of syspref 'HelpSystem'
- Verify that the filter for 'Display location' works
- Verify that in the 'Location' column a hint about the page appears the entry
  was created for
- Edit a staff help entry, verify that submit or close takes you back to the list
- Bonus test: Edit a staff help entry, change the key to 'all', verify that the
  entry now appears for all pages. Change the key to 'help/admin/preferences' and
  verify that it appears now for the preferences page
- Create a staff user with following permisisons only: catalogue (for login),
  edit_help and edit_news
- Test visibility of news / help  editing functionality depending on the
  edit_ permissions
- Run QA tools
Comment 16 M. Tompsett 2017-05-01 00:05:45 UTC
Comment on attachment 62901 [details] [review]
Bug 18483 - Customised help: Enhance staff client with news based, easily editable help system

Review of attachment 62901 [details] [review]:
-----------------------------------------------------------------

::: koha-tmpl/intranet-tmpl/prog/en/includes/header.inc
@@ +98,4 @@
>                      </li>
>                  </ul>
>              </li>
> +                [% IF Koha.Preference('HelpSystem').match('filebased|newsbased')  %]

Is there ever going to be a HelpSystem which does not need the Help link? Is this really necessary?
Comment 17 Marc Véron 2017-05-01 04:25:44 UTC
(In reply to M. Tompsett from comment #16)
> Comment on attachment 62901 [details] [review] [review]
> Bug 18483 - Customised help: Enhance staff client with news based, easily
> editable help system
> 
> Review of attachment 62901 [details] [review] [review]:
> -----------------------------------------------------------------
> 
> ::: koha-tmpl/intranet-tmpl/prog/en/includes/header.inc
> @@ +98,4 @@
> >                      </li>
> >                  </ul>
> >              </li>
> > +                [% IF Koha.Preference('HelpSystem').match('filebased|newsbased')  %]
> 
> Is there ever going to be a HelpSystem which does not need the Help link? Is
> this really necessary?

I implemented this because the help system can totally be turned off (nothing selected in system preference 'HelpSystem').

And 'yes' to the question, or better 'yes, but not yet': 
- I'm thinking about expanding the news based help to the OPAC as well, see Bug 18515 - Use news based help system for OPAC, and I do not want it to trigger the link on staff client.
- I can imagine a help system that for example displays a small help text directly on the screen
Comment 18 Josef Moravec 2017-05-02 11:37:58 UTC
Created attachment 62952 [details] [review]
[SIGNED-OFF] Bug 18483 - Customised help: Enhance staff client with news based, easily editable help system

Koha's staff client has a file based help system with an edit function for
customising. However, the edited files have to be saved and restored with each
release. Otherwise they are overwritten.

As an enhancement or alternative, the existing news system is used to implement a
complementing help system. Similar to the news, the text can be created for all
branches or for individual branches. Help is context sensitive (based on the
existing help system), and it can be created / edited directly from the help page
(based on a user permission). Du to the need of this user permissen, a user
permission for editing news is implemented as well.

Display can be managed with a system preference (Bug 18472: Add system preference
to manage online help system). Preferences default to legacy (fiele based) help.

To test:
- Apply patch on top of Bug 18472, restart memcached and plack
- Update database (Alternative: fresh install)
- Log in as superlibrarian (later we test the permisisons)
- Verify that news behave as before
- Verify that legacy help works as before
- Locate system preferences 'EnableEditingFilebasedHelp' and 'Help system'
- For our tests, set 'EnableEditingFilebasedHelp' to 'No'
- In 'HelpSystem', uncheck 'File based'  (none selected)
- Refresh any page and verify that 'Help' Link in the main menu has vanished
- Check both 'File based' and 'News based'
- Verify that 'Help appears again in top menu
- Click 'Help' for any page, verify that, above the 'classic' filebased help, you
  see a title 'Help for (library name) and two buttons 'Add help for this page'
  and 'Add help for all pages'
- Close the help page
- Go back to system preferences, select 'News based' only for 'HelpSystem'
- Open Help again for any page
- Verify that the text from file based help no longer displays, you should have
  a title and buttons only at the moment.
- Click 'Add help for this page'. You are taken to the form you already know from
  editing 'News'
- Click 'Cancel'. You should be taken back to the help page as before
- Again click 'Add help for this page' and add an easyly identifiable title and
  some text, like you would do with news.
- Leave the new field 'Help key' unchanged.
- Submit. You should be taken back to the help you just created should appear
- Close help page and open it again to verify that the text persists (for this
  page)
- Go to an other page and verify that the help you added for the first page does
  not appear.
- Add a help entry using the button 'Add help for all pages'
- Go back to the first page you entered help for and verify, that it displays it's
  own help text and the text for all pages
- Edit one of the texts, verify that it saves correctly
- Add some more entries and verify that they appear as expected
- Go to More > Tools (in an other tab)
- Verify that the menu entry for News appears/disappears and changes text
  depending on the settings of system preference 'HelpSystem'
- Open 'News' rsp. 'Help', verify that entries appear depending on the settings
  of syspref 'HelpSystem'
- Verify that the filter for 'Display location' works
- Verify that in the 'Location' column a hint about the page appears the entry
  was created for
- Edit a staff help entry, verify that submit or close takes you back to the list
- Bonus test: Edit a staff help entry, change the key to 'all', verify that the
  entry now appears for all pages. Change the key to 'help/admin/preferences' and
  verify that it appears now for the preferences page
- Create a staff user with following permisisons only: catalogue (for login),
  edit_help and edit_news
- Test visibility of news / help  editing functionality depending on the
  edit_ permissions
- Run QA tools

Signed-off-by: Josef Moravec <josef.moravec@gmail.com>
Comment 19 Marc Véron 2017-05-18 07:19:02 UTC Comment hidden (obsolete)
Comment 20 Marc Véron 2017-06-20 15:20:45 UTC
Still applies on current master
Comment 21 Marc Véron 2017-08-04 09:27:59 UTC
Comments from Bug 18472 regarding this enhancement:

(In reply to Marcel de Rooy from comment #20)
> (In reply to Jonathan Druart from comment #19)
> > I personally do not think it is a good idea, I'd like to get other QAers
> > point of view.
> 
> At first glance, I would think so too. But I did not study all code changes.
> 
> Marc: Could you convince the QA team why this is a good idea? What is the
> impact on the news module itself?


Need:
- Having a user editable, page aware help system is a long outstanding need. First time I was asked for goes back to 2012.
- We have libraries interested in Koha who ask for in their requirements.
- Writing a brand new help module would take a lot of time. And who would fund it?

User:
- The news system works very well and libraries are used to use it. The help additons introduced in Bug 18483 enhances the news system to host custom help as well.
- From a user standpoint it is easy to use, you can add whatever you want / need as help. All the benefits of the news system can be used. Custom help items can easyly be added / edited. 
- It can be turned on and off (combined with the existing file based help system or 'standalone'). This Bug 18472 is the basis for turning on and off and/or add additional help systems. 
- There is no change in behavior of news and file based help system if turned off (however this patch allows to turn off the edit function of the existing file based help system).

Impact:
- In Bug 18483, I paid great attention to have a minimal impact on existing code. No changes in .pm files were needed. 
- There is a small database change to have a field to host the page key if a news item is used as help item.

Things to come:
- Since the news system works for both staff client and OPAC it will be easy to implement the editable help for OPAC as well (Bug 18515)

So I kindly ask for Bug 18472 and Bug 18483 to make part of Koha.

Marc